#ifndef MSCALING_H
#define MSCALING_H 1

#include <vector>
#include <iostream>
#include <boost/numeric/ublas/matrix.hpp>
#include <boost/foreach.hpp>
#include <boost/array.hpp>

using namespace boost::numeric::ublas;

namespace Mscaling{

  typedef double Coord;            // a coordinate
  typedef double Distance;         // distance
  typedef matrix<Coord> DistMatrix;// matrix of distance    
  typedef unsigned int Dimensions; // how many dimensions
  typedef unsigned int PointId;    // the id of this point
  typedef unsigned int ClusterId;  // the id of this cluster

  typedef boost::array<Coord, 2> Point;    // a point in R^2
  typedef std::vector<Point> Points;   // collection of points

  
  // distance between two points
  //
  Distance distance(const Point & x, const Point & y);

  // Ramdom generate points
  void random_gen(Points & ps);

  //
  // scale point down
  void scaledown(Points ps, double rate, unsigned int num_iterations = 1000);

  // Dump collection of Points
  //
  std::ostream& operator << (std::ostream& os, Points& cps);
  
};

#endif
